'
' GenerateTestFeed script
'

Dim fso, WshShell, objArgs
Dim retvar
Dim DebugOutToggle
Dim DescriptionDetailsArray

DebugOutToggle = 0

Set WshShell = WScript.CreateObject("WScript.Shell")
Set objArgs = WScript.Arguments
Set fso = CreateObject("Scripting.FileSystemObject")

PathScriptStart = WshShell.CurrentDirectory

ScriptStartTime = Now
ScriptStartTimeUTC = UDate(ScriptStartTime)

If DebugOutToggle = 1 Then
	strDebugOut = ""
	strDebugOut = strDebugOut & "   ScriptStartTime: " & ScriptStartTime & vbCrLf
	strDebugOut = strDebugOut & "ScriptStartTimeUTC: " & ScriptStartTimeUTC & vbCrLf
	retvar = DebugOut(strDebugOut)
End if

TempFeedFile = ""
If objArgs.Count >=1 Then
	TempFeedFile = objArgs(0)
	'DebugOutToggle = 0
End If


If TempFeedFile = "" Then 
	strDebugOut = ""
	strDebugOut = strDebugOut & (" ERROR: Temp feed file not specified" & vbCRLF)
	strDebugOut = strDebugOut & vbCRLF
	strDebugOut = strDebugOut & (" PathScriptStart: " & PathScriptStart & vbCRLF)
	strDebugOut = strDebugOut & ("CurrentDirectory: " & WshShell.CurrentDirectory & vbCRLF)
	'retvar = DebugOut(strDebugOut)
	MsgBox strDebugOut
	ExitScript
End If



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''' Un-comment the following to save a copy of the Awasu '''
''' temporary control file in the channel plug-in folder.'''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'On Error Resume Next
'	fso.CopyFile TempFeedFile, PathScriptStart & "\"
'On Error GoTo 0
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


'Values to be retrieved from Awasu 
NumberOfItems = 1
ItemLink = ""
ItemTitle = ""
ItemDescription = ""


Set oTempFeedIni = new ini

Const ForReading = 1, ForWriting = 2, ForAppending = 8

oTempFeedIni.FileName = TempFeedFile

oTempFeedIni.Section = "ChannelParameters"

oTempFeedIni.Key = "NumberOfItems"
NumberOfItems = oTempFeedIni.Value
If IsNull(NumberOfItems) Or NumberOfItems="" Or Not IsNumeric(NumberOfItems) Then
	NumberOfItems = 1
ElseIf TypeName(NumberOfItems) <> "Integer" Then
	NumberOfItems = Fix(NumberOfItems)
End If
If NumberOfItems < 1 Then NumberOfItems = 1
If NumberOfItems > 10 Then NumberOfItems = 10

If DebugOutToggle = 1 Then
	strDebugOut = ""
	strDebugOut = strDebugOut & "  NumberOfItems: " & NumberOfItems & vbCrLf
	retvar = DebugOut(strDebugOut)
End if


oTempFeedIni.Key = "ItemLink"
ItemLink = oTempFeedIni.Value
If ItemLink = "" Then ItemLink = "http://www.awasu.com"
	
oTempFeedIni.Key = "ItemTitle"
ItemTitle = oTempFeedIni.Value
If ItemTitle = "" Then ItemTitle = "No title"

oTempFeedIni.Key = "ItemDescription"
ItemDescription = oTempFeedIni.Value
If ItemDescription = "" Then ItemDescription = "No description."

If DebugOutToggle = 1 Then
	strDebugOut = ""
	strDebugOut = strDebugOut & "  NumberOfItems: " & NumberOfItems & vbCrLf
	strDebugOut = strDebugOut & "       ItemLink: " & ItemLink & vbCrLf
	strDebugOut = strDebugOut & "      ItemTitle: " & ItemTitle & vbCrLf
	strDebugOut = strDebugOut & "ItemDescription: " & ItemDescription & vbCrLf
	retvar = DebugOut(strDebugOut)
End if



'Feed Header
FeedText = ""
FeedText = FeedText & "<?xml version=""1.0"" encoding=""utf-8"" ?>" & vbCrLf
FeedText = FeedText & "<rss version=""2.0"">" & vbCrLf
FeedText = FeedText & "<channel>" & vbCrLf
FeedText = FeedText & vbTab & "<generator>Generate Feed For Test Use, by David Edwards; davide@telepath.com</generator>" & vbCrLf
FeedText = FeedText & vbTab & "<title>TestFeed</title>" & vbCrLf
FeedText = FeedText & vbTab & "<link>http://awasu.com</link>" & vbCrLf
FeedText = FeedText & vbTab & "<description>Test Feed Generator</description>" & vbCrLf


For ItemCounter = 1 to NumberOfItems
	FeedText = FeedText & vbTab & "<item>" & vbCrLf
	FeedText = FeedText & vbTab & vbTab & "<title>" & ItemTitle & " (#" & ItemCounter & ")" & "</title>" & vbCrLf
	FeedText = FeedText & vbTab & vbTab & "<link>" & ItemLink & "#" & ItemCounter & "-" & ScriptStartTimeUTC & "</link>" & vbCrLf
	FeedText = FeedText & vbTab & vbTab & "<guid>" & ItemLink & "#" & ItemCounter & "-" & ScriptStartTimeUTC & "</guid>" & vbCrLf
	FeedText = FeedText & vbTab & vbTab & "<description>" & ItemDescription & " -- " & ScriptStartTime & "</description>" & vbCrLf
	FeedText = FeedText & vbTab & "</item>" & vbCrLf
Next

FeedText = FeedText & "</channel>" & vbCrLf
FeedText = FeedText & "</rss>" & vbCrLf

retvar = EchoOut(FeedText)

ExitScript

' Create UTC Date from Date
function UDate(oldDate)
  UDate = DateDiff("s", "01/01/1970 00:00:00", oldDate)
end function

' Create Date from UTC date
function unUDate(intTimeStamp)
  unUDate = DateAdd("s", intTimeStamp, "01/01/1970 00:00:00")
end function


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' from http://www.interclasse.com/scripts/class_ini.php

'Class for Ini
'
'A generic class to access ini files
'Just put thi class in your scripts and use it like this :
'
'Dim x 
'set x=new ini 
'x.FileName="C:\WINDOWS\Bureau\ini\wanadoo.ini" 
'x.Section="icone0" 
'x.Key="Id" 
'MsgBox x.Value 
'x.Key="TestKey" 
'x.Value="TestValue" 
'MsgBox x.Value 
'Set x=Nothing 

'File Name : class_ini.vbs
'Requirement : WSH 5.1
'Author : Jean-Luc Antoine
'Submitted : 26/08/2001
'Category : Class

'To use a class, follow this syntax :
'Dim MyObjClass
'set MyObjClass=new MyClass
'MyObjClass.Property="Any value"
'MsgBox MyObjClass.AnotherProperty
'MyObjClass.MyMethod MyParam1,MyParam2
'Set MyObjClass=Nothing
'Very simple, no need to rename any variable nor register any ActiveX.
Class Ini

	Private fso,f

	Public Filename	'Path to the ini File
	Public Section	'[section]
	Public Key	'Key=Value
	Public Default	'Return it when an error occurs

	Private Sub Class_Initialize   ' Setup Initialize event.
		Default=""
		Set fso=CreateObject("Scripting.FileSystemObject")
	End Sub
	Private Sub Class_Terminate   ' Setup Terminate event.
		Set fso=Nothing
	End Sub

	Property Get Content()
		'All the file in a string
		If fso.FileExists(FileName) Then
			Set f=fso.OpenTextFile(FileName,1)
			Content=f.ReadAll
			f.close
			Set f=Nothing
		Else
			Content=""
		End If
	End Property
	Property Let Content(sContent)
		'Create a brand new ini file
		Set f=fso.CreateTextFile(FileName,True)
		f.Write sContent
		f.close
		Set f=Nothing
	End Property

	Property Get ContentArray()
		'All the file in an array of lines
		ContentArray=Split(Content,vbCrLf,-1,1)
	End Property

	Private Sub FindSection(ByRef StartLine, ByRef EndLine)
		Dim x,A,s
		StartLine=-1
		EndLine=-2
		A=ContentArray
		For x=0 To UBound(A)
			s=UCase(Trim(A(x)))
			If s="[" & UCase(section) & "]" Then
				StartLine=x
			Else
				If (Left(s,1)="[") And (Right(s,1)="]") Then
					If StartLine>=0 Then
						EndLine=x-1
						If EndLine>0 Then 'A Space before the next section ?
							If Trim(A(EndLine))="" Then EndLine=EndLine-1
						End If
						Exit Sub
					End If
				End If
			End If
		Next
		If (StartLine>0) And (EndLine<0) Then EndLine=UBound(A)
	End Sub

	Property Get Value()
		'Retrieve the value for the current key in the current section
		Dim x,i,j,A,s
		FindSection i,j
		A=ContentArray
		Value=Default
		'Search only in the good section
		For x=i+1 To j
			s=Trim(A(x))
			If UCase(Left(s,Len(Key)))=UCase(Key) Then
				Select Case Mid(s,Len(Key)+1,1)
				Case "="
					Value=Trim(Mid(s,Len(Key)+2))
					Exit Property
				Case " ",chr(9)
					x=Instr(Len(Key),s,"=")
					Value=Trim(Mid(s,x+1))
					Exit Property
				End Select
			End If
		Next
	End Property
	Property Let Value(sValue)
		' Write the value for a key in a section
		Dim i,j,A,x,s,f
		FindSection i,j
		If i<0 Then 'Session doesn't exist
			Content=Content & vbCrLf & "[" & section & "]" & vbCrLf & Key & "=" & sValue
		Else
			A=ContentArray
			f=-1
			'Search for the key, either the key exists or not
			For x=i+1 To j
				s=Trim(A(x))
				If UCase(Left(s,Len(Key)))=UCase(Key) Then
					Select Case Mid(s,Len(Key)+1,1)
					Case " ",chr(9),"="
						f=x	'Key found
						A(x)=Key & "=" & sValue
					End Select
				End If
			Next
			If f=-1 Then
				'Not found, add it at the end of the section
				Redim Preserve A(UBound(A)+1)
				For x=UBound(A) To j+2 Step -1
					A(x)=A(x-1)
				Next
				A(j+1)=Key & "=" & sValue
			End If
			'Define the content
			s=""
			For x=0 To UBound(A)	
				s=s & A(x) & vbCrLf
			Next
			'Suppress the last CRLF
			If Right(s,2)=vbCrLf Then s=Left(s,Len(s)-2)
			Content=s	'Write it
		End If
	End Property
End Class 
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Function EchoOut (strEcho)
	EchoOut = 0
	wscript.echo strEcho
	EchoOut = 1
End Function


Function DebugOut (strEcho)
	DebugOut = 0
	If DebugOutToggle = 1 Then
		'wscript.echo strEcho
		MsgBox strEcho
		DebugOut = 1
	End If
End Function


Sub ExitScript
	wscript.quit (0)
End Sub